/*-------------------------------------------------------------
 *  etc.h
 *
 *  Siyoung Kim @ Mobile Design P/J, Samsung Electronics
 *
 *-------------------------------------------------------------
 */

#ifndef __ETC_H__
#define __ETC_H__

#include "Def.h"

void Delay(U32 time);
void TuneDelay(void);

void Copy32(U32 sa, U32 da, U32 words); // obsolete
void Copy(U32* sa, U32* da, U32 num);
void Copy(U16* sa, U16* da, U32 num);
void Copy(U8* sa, U8* da, U32 num);

bool Compare32(U32 a1, U32 a2, U32 bytes);  // obsolete
bool Compare(U32* a, U32* b, U32 num);
bool Compare(U16* a, U16* b, U32 num);
bool Compare(U8* a,  U8* b, U32 num);

void CopyUp(U32 uSrcAddr, U32 uDestAddr, U32 uBytes);
void CopyDown(U32 uSrcAddr, U32 uDestAddr, U32 uBytes);
U32  LoadFile(const char* fileName, U32 uDstAddr, bool bAsk = false);
void LoadFile(const char* fileName, U32 uDstAddr, U32& uFileSize, bool bAsk = false);
void SaveToFile(const char* fileName, U32 fileSize, U32 uSrcAddr);
void ConvertBmpToRgb16bpp(U32 fromAddr, U32 toAddr, U32 xSize, U32 ySize);
void ConvertBmpToRgb24bpp(U32 fromAddr, U32 toAddr, U32 xSize, U32 ySize);
void ConvertBmpToRgb(U32 fromAddr, U32 toAddr, U32 xSize, U32 ySize, U32 bpp);
void Dump32(U32 addr, U32 words);
void Dump16(U32 addr, U32 hwords);
void Dump8(U32 addr, U32 bytes);

void InitMemc(void);


#define Outp32(addr, data) (*(volatile U32 *)(addr) = (data))
#define Outp16(addr, data) (*(volatile U16 *)(addr) = (data))
#define Outp8(addr, data)  (*(volatile U8 *)(addr) = (data))
#define Inp32(addr, data) (data = (*(volatile U32 *)(addr)))
#define Inp16(addr, data) (data = (*(volatile U16 *)(addr)))
#define Inp8(addr, data)  (data = (*(volatile U8 *)(addr)))
#define Input32(addr) (*(volatile U32 *)(addr))


#include "uart.h"

#define InitUart() urtInit(0, BAUDRATE)
#define GetInt      urtGetIntNum
#define GetChar     urtGetChar
#define GetKey      urtGetKey
#define Disp        urtPrintf
#define Dbg         urtPrintf
#define PutChar     urtPutChar


#include <stdlib.h>
#define Assert(a) {if (!(a)) {Disp("\n %s(line %d)\n", __FILE__, __LINE__); exit(0);}}

typedef struct FUNC_MENU {
	void (*func)(void); 
	const char *desc;
} FUNC_MENU;

#endif // __ETC_H__

