//====================================================================
// File Name : rtc.c
// Function  : S3C2443 RTC Test Program
// Date      : June. 05, 2005
// Version   : 0.0
// History
//   0.0 : Programming start (June. 05, 2006)
//====================================================================

#ifndef __2443RTC_H__
#define __2443RTC_H__

#ifdef __cplusplus
extern "C" {
#endif


void Test_RTC(void);
void RTC_time_tick(void);
void Rtc_Alarm(void);
void Tick_Count_Set(U32 count);
void Rtc_Alarm_Set();
void Print_RTC(void);
void RTC_Init(void);
void RTC_initialize(void);

void RTC_BATFLT(void);

void __irq Rtc_Tick_ISR(void);
void __irq Rtc_Alarm_ISR(void);

#define TESTYEAR    (0x01)
#define TESTMONTH   (0x12)
#define TESTDATE    (0x31)
#define TESTDAY     (0x02)      //SUN:1 MON:2 TUE:3 WED:4 THU:5 FRI:6 SAT:7   
#define TESTHOUR    (0x23)
#define TESTMIN     (0x59)
#define TESTSEC     (0x55)

#define TESTYEAR2   (0x02)
#define TESTMONTH2  (0x01)
#define TESTDATE2   (0x03)
#define TESTDAY2    (0x03)      //SUN:1 MON:2 TUE:3 WED:4 THU:5 FRI:6 SAT:7   
#define TESTHOUR2   (0x00)
#define TESTMIN2    (0x00)
#define TESTSEC2    (0x00)

#ifdef __cplusplus
}
#endif

#endif  //__2443RTC_H__
