/*********************************************************************
;* Project Name : S3C2443
;*
;* Copyright 2005 by Samsung Electronics, Inc.
;* All rights reserved.
;*
;* Project Description :
;* This software is only for verifying functions of the S3C2443
;* Anybody can use this code without our permission.
;**********************************************************************
;*
;*	Description	:	Camera Module
;*	
;*	History
;*			R0.0 (2006.8. ) : Y.C.Kwon draft
;*
;**********************************************************************/

#include "IIC.h"
#include "Camera.h"

void OpenCameraIIC( int Frequency)
{
	IIC_open( Frequency);
}

void CloseCameraIIC( void)
{
	IIC_close();
}
	
void WriteCameraModule( char CameraIICID, char Addr, char Data)
{
	char D[2];
	
	D[0]=Addr;
	D[1]=Data;
	IIC_Write( CameraIICID, D, 2);
	IIC_Wait();
}

void ReadCameraModule( char CameraIICID, char Addr, char *Data)
{
	IIC_Write( CameraIICID, &Addr, 1);
	IIC_Read( CameraIICID, Data, 1);
	IIC_Wait();
}

void SetupCameraModule( char CameraIICID, char CameraModulData[][2], int CameraModuleDataSize)
{
   	int i;

	ResetCameraModule();
	
	for(i=0; i<CameraModuleDataSize; i++) 
		WriteCameraModule( CameraIICID, CameraModulData[i][0], CameraModulData[i][1]);
}
